#!/bin/sh
# fmacheck_acore.sh COPYRIGHT FUJITSU LIMITED 2021

#set core which fma checek process run.
check_fma()
{
	CPU_ONLINE=`cat /sys/devices/system/cpu/online|awk -F , '{print $1}'`
	case "$CPU_ONLINE" in
	"0-3")
		#IO node
		GOMP_CPU_AFFINITY=0-3
		OMP_NUM_THREADS=4
		;;
	"0-1")
		#CN node
		GOMP_CPU_AFFINITY=0-1
		OMP_NUM_THREADS=2
		;;
	*)
		#probably FX700
		return 0
		;;
	esac

	# export environ
	# DGEMM_MA/DGEMM_NB = OMP_NUM_THREADS * 160
	export GOMP_CPU_AFFINITY
	export OMP_NUM_THREADS
	export DGEMM_MA=$(($OMP_NUM_THREADS * 160))
	export DGEMM_NLOOP=100
	export DGEMM_NB=$(($OMP_NUM_THREADS * 160))
	export DGEMM_LDB=160
	export DGEMM_KK=160
	export DGEMM_LDC=160

	# fma.v210212 [-d] [-b <bmc_mode>] [-m <mode>]
	# -d            指定するとエラー発生時に debug 情報を標準出力へ表示する。
	# -b <bmc_mode> <bmc_mode>=1 の時、bmcd と通信し、エラーログを送信する。
	# -m <mode>     <mode>=1 のとき、エラーがなくてもエラーと判断する。(debug用途)
	if [[ ! -e /opt/FJSVxos/cpuras/sbin/fma.v210212 ]]; then
	     echo "/opt/FJSVxos/cpuras/sbin/fma.v210212 is not exist."
	     return 0
	fi
	/opt/FJSVxos/cpuras/sbin/fma.v210212 -d -b 1
	if [ $? -eq 0 ]; then
		return 0
	else
		echo `date`":FMA ras panic by acore check" 
		echo c > /proc/sysrq-trigger
	fi
}

OUTPUT=`check_fma`
echo $OUTPUT >> /etc/opt/FJSVtcs/prm/syshook/os/cpuras/log
exit 0
